--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   12:40:16 10/18/2010
-- Design Name:   
-- Module Name:   F:/Projekte/FPGA/PS2_Simple/PS2_tb.vhd
-- Project Name:  PS2
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: PS2_Keyboard
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY PS2_tb IS
END PS2_tb;
 
ARCHITECTURE behavior OF PS2_tb IS 
 
 	procedure PS2Send( signal din :  in std_logic_vector(7 downto 0); 
						    signal ps2c : OUT std_logic;
						    signal ps2d : OUT std_logic) is
	variable parity : std_logic := '1';
	begin
   	wait for 1 ns;
		ps2c  <= '1';
		ps2d  <= '1';
		wait for 5us;
		ps2d  <= '0';  -- startbit
		wait for 20us;
		ps2c  <= '0';
		wait for 40us;
		ps2c  <= '1';
		wait for 20us;
		
		parity := '1';
		for i in 0 to 7 loop
		   ps2d <= din(i);
			if(din(i)='1') then 
			   parity := not parity; 
			end if;
			wait for 20us;
			ps2c  <= '0';
			wait for 40us;
			ps2c  <= '1';
			wait for 20us;
		end loop;
		
	   ps2d <= parity;  -- parity
   	wait for 20us;
		ps2c  <= '0';
		wait for 40us;
		ps2c  <= '1';
		wait for 20us;
	
	   ps2d <= '1';     -- stopbit
   	wait for 20us;
		ps2c  <= '0';
		wait for 40us;
		ps2c  <= '1';
		wait for 20us;
	end procedure;

    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT PS2_Keyboard
    PORT(
         PS2_Data : IN  std_logic;
         PS2_Clk : IN  std_logic;
         RxData : OUT  std_logic_vector(7 downto 0);
         RxActive : OUT  std_logic;
         BreakCode : OUT  std_logic;
         ExtKeycode : OUT  std_logic;
         DataReady : OUT  std_logic;
         DataFetched : IN  std_logic;
         CLK : IN  std_logic
        );
    END COMPONENT;
    
   signal TxData : std_logic_vector(7 downto 0);

   --Inputs
   signal PS2_Data : std_logic := '0';
   signal PS2_Clk : std_logic := '0';
   signal DataFetched : std_logic := '0';
   signal CLK : std_logic := '0';

 	--Outputs
   signal RxData : std_logic_vector(7 downto 0);
   signal RxActive : std_logic;
   signal BreakCode : std_logic;
   signal ExtKeycode : std_logic;
   signal DataReady : std_logic;

   -- Clock period definitions
   constant PS2_Clk_period : time := 10 ns;
   constant CLK_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: PS2_Keyboard PORT MAP (
          PS2_Data => PS2_Data,
          PS2_Clk => PS2_Clk,
          RxData => RxData,
          RxActive => RxActive,
          BreakCode => BreakCode,
          ExtKeycode => ExtKeycode,
          DataReady => DataReady,
          DataFetched => DataFetched,
          CLK => CLK
        );

   -- Clock process definitions
	CLK <= not CLK after CLK_period/2;

   -- Stimulus process
	DataFetched <= DataReady after 10 us; -- fake handshake
	
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      wait for 100 ns;	
      
      TXData<=x"AA";
      PS2Send(TXData,PS2_Clk,PS2_Data);
      wait for 100 us;	

      TXData<=x"55";
      PS2Send(TXData,PS2_Clk,PS2_Data);
      wait for 100 us;	

      TXData<=x"11";
      PS2Send(TXData,PS2_Clk,PS2_Data);
      wait for 100 us;	

      TXData<=x"80";
      PS2Send(TXData,PS2_Clk,PS2_Data);
      wait for 100 us;	

      TXData<=x"01";
      PS2Send(TXData,PS2_Clk,PS2_Data);
      wait for 100 us;	
      TXData<=x"F0";
      PS2Send(TXData,PS2_Clk,PS2_Data);
      wait for 100 us;	
      TXData<=x"01";
      PS2Send(TXData,PS2_Clk,PS2_Data);
      wait for 100 us;	

      TXData<=x"E0";
      PS2Send(TXData,PS2_Clk,PS2_Data);
      wait for 100 us;	
      TXData<=x"C3";
      PS2Send(TXData,PS2_Clk,PS2_Data);
      wait for 100 us;	
      TXData<=x"E0";
      PS2Send(TXData,PS2_Clk,PS2_Data);
      wait for 100 us;	
      TXData<=x"F0";
      PS2Send(TXData,PS2_Clk,PS2_Data);
      wait for 100 us;	
      TXData<=x"C3";
      PS2Send(TXData,PS2_Clk,PS2_Data);
      wait for 100 us;	
      
   end process;

END;
